Jump to content

Lisp required to select all mtext within an enclosed polyline and rotate the text to the angle of the longest segment of the polyline


Recommended Posts

Posted (edited)

Hi I am new here and require some assistance.  I am trying to create a lisp routine that where you select all the enclosed polylines (typically parcels) within a drawing and then it will rotate any Mtext (typically Lot number and area) by the angle of the longest segment of the of the enclosed polyline which bounds the Mtext.

 

The attached lisp performs the task required but you have to select both the polyline and then the Mtext each time.  

 

I was hoping to do this automatically so that the operator only needs to select the polylines globally and then the lisp will step through each polyline and rotate the bounded Mtexts automatically as in some instances there are over 10000 enclosed polyline to process.  I have attached a dwg for assistance.

 

(defun c:RotateMtext ()
  (setq ent (car (entsel "\nSelect enclosed polyline: ")))
  (setq mtext (car (entsel "\nSelect MTEXT: ")))
  (if (and ent mtext)
    (progn
      (setq entObj (entget ent))
      (setq mtextObj (entget mtext))
      (if (eq (cdr (assoc 0 entObj)) "LWPOLYLINE")
        (progn
          (setq vertices '())
          (foreach item entObj
            (if (or (eq (car item) 10) (eq (car item) 11))
              (setq vertices (append vertices (list (cdr item))))
            )
          )
          (setq longestSide 0 longestAngle 0)
          (repeat (- (length vertices) 1)
            (setq p1 (nth 0 vertices) p2 (nth 1 vertices))
            (setq vertices (cdr vertices))
            (setq dist (distance p1 p2))
            (if (> dist longestSide)
              (progn
                (setq longestSide dist)
                (setq longestAngle (angle p1 p2))
              )
            )
          )
          (setq mtextObj (subst (cons 50 longestAngle) (assoc 50 mtextObj) mtextObj))
          (entmod mtextObj)
          (princ "\nMTEXT rotated successfully.")
        )
        (princ "\nSelected entity is not a polyline.")
      )
    )
    (princ "\nInvalid selection.")
  )
  (princ)
)

Drawing2.dwgFetching info...

RotateMtext.lspFetching info...

Edited by SLW210
Added Code Tags!!
Posted

Please use Code Tags for your Code in the future. (<> in the Editor toolbar)

Posted

Hello
You need:
1) Create a selection set of the LWpolylines and another with the MTEXT
2) Loop through each of the polylines in the set, obtain the points they are composed of in a list, and create a selection set with '(ssget "_CP" ...)' using that list of points as a filter.
3) With the current polyline and the MTEXT obtained with ssget, call your function (you would have to modify it to accept 'ent' and 'mtext' as arguments and override the two calls to '(car (entsel...')' in your code).

I hope I've given you some guidance. I can't be more explicit at the moment: I don't have a computer in front of me.

Posted
  On 3/17/2025 at 11:55 AM, GLAVCVS said:

Hello
You need:
1) Create a selection set of the LWpolylines and another with the MTEXT
2) Loop through each of the polylines in the set, obtain the points they are composed of in a list, and create a selection set with '(ssget "_CP" ...)' using that list of points as a filter.
3) With the current polyline and the MTEXT obtained with ssget, call your function (you would have to modify it to accept 'ent' and 'mtext' as arguments and override the two calls to '(car (entsel...')' in your code).

I hope I've given you some guidance. I can't be more explicit at the moment: I don't have a computer in front of me.

Expand  

Thankyou for your reply but I really do not know alot about writing lisps.  The example I supplied was generated by ChatGTP. But again thankyou

Posted (edited)

I kept most of your code.

What I added: 

- code to determine if a point is inside a closed polyline.  

What the code does is cast a RAY (half a XLINE, just to one side) from said point (being the insert point of the MTEXT).  If that ray touches/intersects the polyline an odd number of times, then the point is inside.

 

- You don't have to select the MTEXT.

You select the polyline, then the script will select all MTEXTS and only rotate the MTEXTS that are inside the polyline

 

 

(vl-load-com) 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This section is all about determining if a point is inside a closed polyline

(defun c:testray ( / pt)
	
	(drawxRay (setq pt (getpoint "\nPoint: ")) (list 1.0 0.0))

)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;				 

(defun drawxRay (pt vec)
 (entmakex (list (cons 0 "RAY")
                 (cons 100 "AcDbEntity")
                 (cons 100 "AcDbRay")
                 (cons 10 pt)
                 (cons 11 vec))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Intersections  -  Lee Mac
;; http://www.lee-mac.com/intersectionfunctions.html
;; Returns a list of all points of intersection between two objects
;; for the given intersection mode.
;; ob1,ob2 - [vla] VLA-Objects
;;     mod - [int] acextendoption enum of intersectwith method
        ;; acextendnone 	      Do not extend either object
        ;; acextendthisentity 	Extend obj1 to meet obj2
        ;; acextendotherentity 	Extend obj2 to meet obj1
        ;; acextendboth 	      Extend both objects
(defun LM:intersections ( ob1 ob2 mod / lst rtn )
    (if (and (vlax-method-applicable-p ob1 'intersectwith)
             (vlax-method-applicable-p ob2 'intersectwith)
             (setq lst (vlax-invoke ob1 'intersectwith ob2 mod))
        )
        (repeat (/ (length lst) 3)
            (setq rtn (cons (list (car lst) (cadr lst) (caddr lst)) rtn)
                  lst (cdddr lst)
            )
        )
    )
    (reverse rtn)
)

;;  what this function does: from point pt we draw a RAY to the right.  We detect intersections of the ray with the closed polyline.
;;  => if the number of intersections is odd -> this means the point is inside the polygon, and the ray exits the polygon at the last intersection.
;;  => if the number of intersections is even (0, 2, 4...) -> the point is outside the polygon.  The ray doesn't intersect, or it enters then exits...
(defun point_inside_closed_polyline (pt pline / ray ins)
	(setq ray (drawxRay pt (list 1.0 0.0)))
	(setq ins (LM:intersections 
					(vlax-ename->vla-object pline) 
					(vlax-ename->vla-object ray) 
					acextendnone
	))
	
	;; delete the ray
	(entdel ray)
	(if (= 0 (rem (length ins) 2)) nil T)			;; (rem number 2) returns 1 when number is odd, 0 when even.  We return T when odd, nil when even
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



(defun c:RotateMtext ( / ent mtexts i mtext is_inside pt entObj mtextObj vertices longestSide longestAngle p1 p2 dist)		;; don't forget these.  Local variables must be listed like this.
	(setq ent (car (entsel "\nSelect enclosed polyline: ")))
	
	;; this selects all MTEXTS
	(setq mtexts (ssget "_x" (list (cons 0 "MTEXT") )))
	(setq i 0)
	(repeat (sslength mtexts)
	
			;;(setq mtext (car (entsel "\nSelect MTEXT: ")))
			(setq mtext (ssname mtexts i))
		  
			(setq is_inside (point_inside_closed_polyline (setq pt (cdr (assoc 10 (entget mtext)))) ent))
		  
		  (if (and ent mtext is_inside)
			(progn
			
			  (setq entObj (entget ent))
			  (setq mtextObj (entget mtext))
			  (if (eq (cdr (assoc 0 entObj)) "LWPOLYLINE")
				(progn
				  (setq vertices '())
				  (foreach item entObj
					(if (or (eq (car item) 10) (eq (car item) 11))
					  (setq vertices (append vertices (list (cdr item))))
					)
				  )
				  (setq longestSide 0 longestAngle 0)
				  (repeat (- (length vertices) 1)
					(setq p1 (nth 0 vertices) p2 (nth 1 vertices))
					(setq vertices (cdr vertices))
					(setq dist (distance p1 p2))
					(if (> dist longestSide)
					  (progn
						(setq longestSide dist)
						(setq longestAngle (angle p1 p2))
					  )
					)
				  )
				  (setq mtextObj (subst (cons 50 longestAngle) (assoc 50 mtextObj) mtextObj))
				  (entmod mtextObj)
				  (princ "\nMTEXT rotated successfully.")
				)
				(princ "\nSelected entity is not a polyline.")
			  )
			)
			(princ "\nInvalid selection.")
		  )
		(setq i (+ i 1))
	)
	

  (princ)
)

 

 

Happy with this?

Edited by Emmanuel Delay
  • Agree 1
Posted
  On 3/17/2025 at 11:55 AM, GLAVCVS said:

Hello
You need:
1) Create a selection set of the LWpolylines and another with the MTEXT
2) Loop through each of the polylines in the set, obtain the points they are composed of in a list, and create a selection set with '(ssget "_CP" ...)' using that list of points as a filter.
3) With the current polyline and the MTEXT obtained with ssget, call your function (you would have to modify it to accept 'ent' and 'mtext' as arguments and override the two calls to '(car (entsel...')' in your code).

I hope I've given you some guidance. I can't be more explicit at the moment: I don't have a computer in front of me.

Expand  

 

I think my approach was somewhat hasty.
Without a doubt: the most appropriate approach is the one suggested by @Emmanuel Delay

  On 3/17/2025 at 2:17 PM, Emmanuel Delay said:

I kept most of your code.

What I added: 

- code to determine if a point is inside a closed polyline.  

What the code does is cast a RAY (half a XLINE, just to one side) from said point (being the insert point of the MTEXT).  If that ray touches/intersects the polyline an odd number of times, then the point is inside.

 

- You don't have to select the MTEXT.

You select the polyline, then the script will select all MTEXTS and only rotate the MTEXTS that are inside the polyline

 

 

(vl-load-com) 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This section is all about determining if a point is inside a closed polyline

(defun c:testray ( / pt)
	
	(drawxRay (setq pt (getpoint "\nPoint: ")) (list 1.0 0.0))

)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;				 

(defun drawxRay (pt vec)
 (entmakex (list (cons 0 "RAY")
                 (cons 100 "AcDbEntity")
                 (cons 100 "AcDbRay")
                 (cons 10 pt)
                 (cons 11 vec))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Intersections  -  Lee Mac
;; http://www.lee-mac.com/intersectionfunctions.html
;; Returns a list of all points of intersection between two objects
;; for the given intersection mode.
;; ob1,ob2 - [vla] VLA-Objects
;;     mod - [int] acextendoption enum of intersectwith method
        ;; acextendnone 	      Do not extend either object
        ;; acextendthisentity 	Extend obj1 to meet obj2
        ;; acextendotherentity 	Extend obj2 to meet obj1
        ;; acextendboth 	      Extend both objects
(defun LM:intersections ( ob1 ob2 mod / lst rtn )
    (if (and (vlax-method-applicable-p ob1 'intersectwith)
             (vlax-method-applicable-p ob2 'intersectwith)
             (setq lst (vlax-invoke ob1 'intersectwith ob2 mod))
        )
        (repeat (/ (length lst) 3)
            (setq rtn (cons (list (car lst) (cadr lst) (caddr lst)) rtn)
                  lst (cdddr lst)
            )
        )
    )
    (reverse rtn)
)

;;  what this function does: from point pt we draw a RAY to the right.  We detect intersections of the ray with the closed polyline.
;;  => if the number of intersections is odd -> this means the point is inside the polygon, and the ray exits the polygon at the last intersection.
;;  => if the number of intersections is even (0, 2, 4...) -> the point is outside the polygon.  The ray doesn't intersect, or it enters then exits...
(defun point_inside_closed_polyline (pt pline / ray ins)
	(setq ray (drawxRay pt (list 1.0 0.0)))
	(setq ins (LM:intersections 
					(vlax-ename->vla-object pline) 
					(vlax-ename->vla-object ray) 
					acextendnone
	))
	
	;; delete the ray
	(entdel ray)
	(if (= 0 (rem (length ins) 2)) nil T)			;; (rem number 2) returns 1 when number is odd, 0 when even.  We return T when odd, nil when even
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



(defun c:RotateMtext ( / ent mtexts i mtext is_inside pt entObj mtextObj vertices longestSide longestAngle p1 p2 dist)		;; don't forget these.  Local variables must be listed like this.
	(setq ent (car (entsel "\nSelect enclosed polyline: ")))
	
	;; this selects all MTEXTS
	(setq mtexts (ssget "_x" (list (cons 0 "MTEXT") )))
	(setq i 0)
	(repeat (sslength mtexts)
	
			;;(setq mtext (car (entsel "\nSelect MTEXT: ")))
			(setq mtext (ssname mtexts i))
		  
			(setq is_inside (point_inside_closed_polyline (setq pt (cdr (assoc 10 (entget mtext)))) ent))
		  
		  (if (and ent mtext is_inside)
			(progn
			
			  (setq entObj (entget ent))
			  (setq mtextObj (entget mtext))
			  (if (eq (cdr (assoc 0 entObj)) "LWPOLYLINE")
				(progn
				  (setq vertices '())
				  (foreach item entObj
					(if (or (eq (car item) 10) (eq (car item) 11))
					  (setq vertices (append vertices (list (cdr item))))
					)
				  )
				  (setq longestSide 0 longestAngle 0)
				  (repeat (- (length vertices) 1)
					(setq p1 (nth 0 vertices) p2 (nth 1 vertices))
					(setq vertices (cdr vertices))
					(setq dist (distance p1 p2))
					(if (> dist longestSide)
					  (progn
						(setq longestSide dist)
						(setq longestAngle (angle p1 p2))
					  )
					)
				  )
				  (setq mtextObj (subst (cons 50 longestAngle) (assoc 50 mtextObj) mtextObj))
				  (entmod mtextObj)
				  (princ "\nMTEXT rotated successfully.")
				)
				(princ "\nSelected entity is not a polyline.")
			  )
			)
			(princ "\nInvalid selection.")
		  )
		(setq i (+ i 1))
	)
	

  (princ)
)

 

 

Happy with this?

Expand  

 

  • Like 1
Posted
  On 3/17/2025 at 7:29 PM, GLAVCVS said:

 

I think my approach was somewhat hasty.
Without a doubt: the most appropriate approach is the one suggested by @Emmanuel Delay

 

Expand  

 

  On 3/17/2025 at 2:17 PM, Emmanuel Delay said:

I kept most of your code.

What I added: 

- code to determine if a point is inside a closed polyline.  

What the code does is cast a RAY (half a XLINE, just to one side) from said point (being the insert point of the MTEXT).  If that ray touches/intersects the polyline an odd number of times, then the point is inside.

 

- You don't have to select the MTEXT.

You select the polyline, then the script will select all MTEXTS and only rotate the MTEXTS that are inside the polyline

 

 

(vl-load-com) 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This section is all about determining if a point is inside a closed polyline

(defun c:testray ( / pt)
	
	(drawxRay (setq pt (getpoint "\nPoint: ")) (list 1.0 0.0))

)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;				 

(defun drawxRay (pt vec)
 (entmakex (list (cons 0 "RAY")
                 (cons 100 "AcDbEntity")
                 (cons 100 "AcDbRay")
                 (cons 10 pt)
                 (cons 11 vec))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Intersections  -  Lee Mac
;; http://www.lee-mac.com/intersectionfunctions.html
;; Returns a list of all points of intersection between two objects
;; for the given intersection mode.
;; ob1,ob2 - [vla] VLA-Objects
;;     mod - [int] acextendoption enum of intersectwith method
        ;; acextendnone 	      Do not extend either object
        ;; acextendthisentity 	Extend obj1 to meet obj2
        ;; acextendotherentity 	Extend obj2 to meet obj1
        ;; acextendboth 	      Extend both objects
(defun LM:intersections ( ob1 ob2 mod / lst rtn )
    (if (and (vlax-method-applicable-p ob1 'intersectwith)
             (vlax-method-applicable-p ob2 'intersectwith)
             (setq lst (vlax-invoke ob1 'intersectwith ob2 mod))
        )
        (repeat (/ (length lst) 3)
            (setq rtn (cons (list (car lst) (cadr lst) (caddr lst)) rtn)
                  lst (cdddr lst)
            )
        )
    )
    (reverse rtn)
)

;;  what this function does: from point pt we draw a RAY to the right.  We detect intersections of the ray with the closed polyline.
;;  => if the number of intersections is odd -> this means the point is inside the polygon, and the ray exits the polygon at the last intersection.
;;  => if the number of intersections is even (0, 2, 4...) -> the point is outside the polygon.  The ray doesn't intersect, or it enters then exits...
(defun point_inside_closed_polyline (pt pline / ray ins)
	(setq ray (drawxRay pt (list 1.0 0.0)))
	(setq ins (LM:intersections 
					(vlax-ename->vla-object pline) 
					(vlax-ename->vla-object ray) 
					acextendnone
	))
	
	;; delete the ray
	(entdel ray)
	(if (= 0 (rem (length ins) 2)) nil T)			;; (rem number 2) returns 1 when number is odd, 0 when even.  We return T when odd, nil when even
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



(defun c:RotateMtext ( / ent mtexts i mtext is_inside pt entObj mtextObj vertices longestSide longestAngle p1 p2 dist)		;; don't forget these.  Local variables must be listed like this.
	(setq ent (car (entsel "\nSelect enclosed polyline: ")))
	
	;; this selects all MTEXTS
	(setq mtexts (ssget "_x" (list (cons 0 "MTEXT") )))
	(setq i 0)
	(repeat (sslength mtexts)
	
			;;(setq mtext (car (entsel "\nSelect MTEXT: ")))
			(setq mtext (ssname mtexts i))
		  
			(setq is_inside (point_inside_closed_polyline (setq pt (cdr (assoc 10 (entget mtext)))) ent))
		  
		  (if (and ent mtext is_inside)
			(progn
			
			  (setq entObj (entget ent))
			  (setq mtextObj (entget mtext))
			  (if (eq (cdr (assoc 0 entObj)) "LWPOLYLINE")
				(progn
				  (setq vertices '())
				  (foreach item entObj
					(if (or (eq (car item) 10) (eq (car item) 11))
					  (setq vertices (append vertices (list (cdr item))))
					)
				  )
				  (setq longestSide 0 longestAngle 0)
				  (repeat (- (length vertices) 1)
					(setq p1 (nth 0 vertices) p2 (nth 1 vertices))
					(setq vertices (cdr vertices))
					(setq dist (distance p1 p2))
					(if (> dist longestSide)
					  (progn
						(setq longestSide dist)
						(setq longestAngle (angle p1 p2))
					  )
					)
				  )
				  (setq mtextObj (subst (cons 50 longestAngle) (assoc 50 mtextObj) mtextObj))
				  (entmod mtextObj)
				  (princ "\nMTEXT rotated successfully.")
				)
				(princ "\nSelected entity is not a polyline.")
			  )
			)
			(princ "\nInvalid selection.")
		  )
		(setq i (+ i 1))
	)
	

  (princ)
)

 

 

Happy with this?

Expand  

Thankyou so much.  The auto rotation of the mtext is perfect.  Is there a way to select all the enclosed polylines globally and for the lisp step through each polyline and rotate the text without having to manually select each polyline

Posted

Sure.

Same thing, a SSGET, then loop through them all, now counting with j.

 

Keep the other functions; here I only post the main function.

 


(defun c:RotateMtext ( / ent mtexts plines i j mtext is_inside pt entObj mtextObj vertices longestSide longestAngle p1 p2 dist)		;; don't forget these.  Local variables must be listed like this.
	
	;;(setq ent (car (entsel "\nSelect enclosed polyline: ")))
	(setq j 0)
	;;(setq plines (ssget "_x" (list (cons 0 "LWPOLYLINE") (cons 70 129) )))
	(setq plines (ssget (list (cons 0 "LWPOLYLINE") (cons 70 129) )))
	(repeat (sslength plines)
		(setq ent (ssname plines j))
	
		;; this selects all MTEXTS
		(setq mtexts (ssget "_x" (list (cons 0 "MTEXT") )))
		(setq i 0)
		(repeat (sslength mtexts)
		
				;;(setq mtext (car (entsel "\nSelect MTEXT: ")))
				(setq mtext (ssname mtexts i))
			  
				(setq is_inside (point_inside_closed_polyline (setq pt (cdr (assoc 10 (entget mtext)))) ent))
				(if is_inside
				  (princ "\n*")		  
				  (princ "\n|")
				)  
			  
			  (if (and ent mtext is_inside)
				(progn
				
				  (setq entObj (entget ent))
				  (setq mtextObj (entget mtext))
				  (if (eq (cdr (assoc 0 entObj)) "LWPOLYLINE")
					(progn
					  (setq vertices '())
					  (foreach item entObj
						(if (or (eq (car item) 10) (eq (car item) 11))
						  (setq vertices (append vertices (list (cdr item))))
						)
					  )
					  (setq longestSide 0 longestAngle 0)
					  (repeat (- (length vertices) 1)
						(setq p1 (nth 0 vertices) p2 (nth 1 vertices))
						(setq vertices (cdr vertices))
						(setq dist (distance p1 p2))
						(if (> dist longestSide)
						  (progn
							(setq longestSide dist)
							(setq longestAngle (angle p1 p2))
						  )
						)
					  )
					  (setq mtextObj (subst (cons 50 longestAngle) (assoc 50 mtextObj) mtextObj))
					  (entmod mtextObj)
					  (princ "\nMTEXT rotated successfully.")
					)
					(princ "\nSelected entity is not a polyline.")
				  )
				)
				(princ "\nInvalid selection.")
			  )
			(setq i (+ i 1))
		)  ;; ending (repeat (sslength mtexts)
	
	
		(setq j (+ j 1))
	)		;; ending (repeat (sslength plines)

  (princ)
)

 

Notice the line 
(setq plines (ssget "_x" (list (cons 0 "LWPOLYLINE") (cons 70 129) )))

 

the "_X" selects everything in the whole drawing.  If you leave away the "_X"  (which is how I saved the code) then the user is still asked to select the polylines.

See which fits you best.

Posted (edited)

Just a cooment I usually go other way as the text is implied within a pline, if it has no arcs the use bpoly and make a new one get vretices then simple check for longest one, rotate text erase poly. Much easier than finding text or opposite using ray to find a polyline.

 

Edited by BIGAL
Posted

@BIGAL Without a doubt, the easiest option is to call "boundary" in one way or another.
The problem is that there are always times when boundary doesn't work as expected.
This, at least, is my experience.

Posted

Yeah, it depends if the shapes are simple and far apart, 

or like a puzzle: irregular and possibly interlocking

Posted
  On 3/18/2025 at 9:20 AM, Emmanuel Delay said:

Sure.

Same thing, a SSGET, then loop through them all, now counting with j.

 

Keep the other functions; here I only post the main function.

 


(defun c:RotateMtext ( / ent mtexts plines i j mtext is_inside pt entObj mtextObj vertices longestSide longestAngle p1 p2 dist)		;; don't forget these.  Local variables must be listed like this.
	
	;;(setq ent (car (entsel "\nSelect enclosed polyline: ")))
	(setq j 0)
	;;(setq plines (ssget "_x" (list (cons 0 "LWPOLYLINE") (cons 70 129) )))
	(setq plines (ssget (list (cons 0 "LWPOLYLINE") (cons 70 129) )))
	(repeat (sslength plines)
		(setq ent (ssname plines j))
	
		;; this selects all MTEXTS
		(setq mtexts (ssget "_x" (list (cons 0 "MTEXT") )))
		(setq i 0)
		(repeat (sslength mtexts)
		
				;;(setq mtext (car (entsel "\nSelect MTEXT: ")))
				(setq mtext (ssname mtexts i))
			  
				(setq is_inside (point_inside_closed_polyline (setq pt (cdr (assoc 10 (entget mtext)))) ent))
				(if is_inside
				  (princ "\n*")		  
				  (princ "\n|")
				)  
			  
			  (if (and ent mtext is_inside)
				(progn
				
				  (setq entObj (entget ent))
				  (setq mtextObj (entget mtext))
				  (if (eq (cdr (assoc 0 entObj)) "LWPOLYLINE")
					(progn
					  (setq vertices '())
					  (foreach item entObj
						(if (or (eq (car item) 10) (eq (car item) 11))
						  (setq vertices (append vertices (list (cdr item))))
						)
					  )
					  (setq longestSide 0 longestAngle 0)
					  (repeat (- (length vertices) 1)
						(setq p1 (nth 0 vertices) p2 (nth 1 vertices))
						(setq vertices (cdr vertices))
						(setq dist (distance p1 p2))
						(if (> dist longestSide)
						  (progn
							(setq longestSide dist)
							(setq longestAngle (angle p1 p2))
						  )
						)
					  )
					  (setq mtextObj (subst (cons 50 longestAngle) (assoc 50 mtextObj) mtextObj))
					  (entmod mtextObj)
					  (princ "\nMTEXT rotated successfully.")
					)
					(princ "\nSelected entity is not a polyline.")
				  )
				)
				(princ "\nInvalid selection.")
			  )
			(setq i (+ i 1))
		)  ;; ending (repeat (sslength mtexts)
	
	
		(setq j (+ j 1))
	)		;; ending (repeat (sslength plines)

  (princ)
)

 

Notice the line 
(setq plines (ssget "_x" (list (cons 0 "LWPOLYLINE") (cons 70 129) )))

 

the "_X" selects everything in the whole drawing.  If you leave away the "_X"  (which is how I saved the code) then the user is still asked to select the polylines.

See which fits you best.

Expand  

Thankyou so much.  This is perfect.  10000 pieces of texts rotated perfectly in a matter of seconds

  • Like 1
Posted
  On 3/18/2025 at 11:21 AM, andyb57J said:

Thankyou so much.  This is perfect.  10000 pieces of texts rotated perfectly in a matter of seconds

Expand  

Some of the Mtexts was orientated so that it was upside down on the screen.  Is there a way to have the Mtetxts always rotated so that it is oriented correctly

Posted

Okay, let's say: when the angle is between 90° and 270° we turn it 180°.

 

                      (and

                                    (> longestAngle  (/ pi 2))  ;; 90°
                                    (< longestAngle  (/ (* 3 pi) 2))   ;; 270°

                       )

 

Pick other values if you want.

 


(defun c:RotateMtext ( / ent mtexts plines i j mtext is_inside pt ang entObj mtextObj vertices longestSide longestAngle p1 p2 dist)		;; don't forget these.  Local variables must be listed like this.
	
	;;(setq ent (car (entsel "\nSelect enclosed polyline: ")))
	(setq j 0)
	;;(setq plines (ssget "_x" (list (cons 0 "LWPOLYLINE") (cons 70 129) )))
	(setq plines (ssget (list (cons 0 "LWPOLYLINE") (cons 70 129) )))
	(repeat (sslength plines)
		(setq ent (ssname plines j))
	
		;; this selects all MTEXTS
		(setq mtexts (ssget "_x" (list (cons 0 "MTEXT") )))
		(setq i 0)
		(repeat (sslength mtexts)
		
				;;(setq mtext (car (entsel "\nSelect MTEXT: ")))
				(setq mtext (ssname mtexts i))
			  
				(setq is_inside (point_inside_closed_polyline (setq pt (cdr (assoc 10 (entget mtext)))) ent))
 
			  
			  (if (and ent mtext is_inside)
				(progn
				
				  (setq entObj (entget ent))
				  (setq mtextObj (entget mtext))
				  (if (eq (cdr (assoc 0 entObj)) "LWPOLYLINE")
					(progn
					  (setq vertices '())
					  (foreach item entObj
						(if (or (eq (car item) 10) (eq (car item) 11))
						  (setq vertices (append vertices (list (cdr item))))
						)
					  )
					  (setq longestSide 0 longestAngle 0)
					  (repeat (- (length vertices) 1)
						(setq p1 (nth 0 vertices) p2 (nth 1 vertices))
						(setq vertices (cdr vertices))
						(setq dist (distance p1 p2))
						(if (> dist longestSide)
						  (progn
						  
							(setq longestSide dist)
							(setq longestAngle (angle p1 p2))
							(princ "\n")
							(princ longestAngle)
							(if 
								(and 									;; if text angle is between 90° and 270° => we turn in 180° extra 
									(> longestAngle  (/ pi 2))
									(< longestAngle  (/ (* 3 pi) 2))
								)
								(progn	
									(princ "*")
									(setq longestAngle (- longestAngle pi))
									(princ longestAngle)
								)
							)

						  )
						)
					  )
					  (setq mtextObj (subst (cons 50 longestAngle) (assoc 50 mtextObj) mtextObj))
					  (entmod mtextObj)
					  (princ "\nMTEXT rotated successfully.")
					)
					(princ "\nSelected entity is not a polyline.")
				  )
				)
				;;(princ "\nInvalid selection.")
			  )
			(setq i (+ i 1))
		)  ;; ending (repeat (sslength mtexts)
	
	
		(setq j (+ j 1))
	)		;; ending (repeat (sslength plines)

  (princ)
)

...

Posted
  On 3/18/2025 at 12:53 PM, Emmanuel Delay said:

Okay, let's say: when the angle is between 90° and 270° we turn it 180°.

 

                      (and

                                    (> longestAngle  (/ pi 2))  ;; 90°
                                    (< longestAngle  (/ (* 3 pi) 2))   ;; 270°

                       )

 

Pick other values if you want.

 


(defun c:RotateMtext ( / ent mtexts plines i j mtext is_inside pt ang entObj mtextObj vertices longestSide longestAngle p1 p2 dist)		;; don't forget these.  Local variables must be listed like this.
	
	;;(setq ent (car (entsel "\nSelect enclosed polyline: ")))
	(setq j 0)
	;;(setq plines (ssget "_x" (list (cons 0 "LWPOLYLINE") (cons 70 129) )))
	(setq plines (ssget (list (cons 0 "LWPOLYLINE") (cons 70 129) )))
	(repeat (sslength plines)
		(setq ent (ssname plines j))
	
		;; this selects all MTEXTS
		(setq mtexts (ssget "_x" (list (cons 0 "MTEXT") )))
		(setq i 0)
		(repeat (sslength mtexts)
		
				;;(setq mtext (car (entsel "\nSelect MTEXT: ")))
				(setq mtext (ssname mtexts i))
			  
				(setq is_inside (point_inside_closed_polyline (setq pt (cdr (assoc 10 (entget mtext)))) ent))
 
			  
			  (if (and ent mtext is_inside)
				(progn
				
				  (setq entObj (entget ent))
				  (setq mtextObj (entget mtext))
				  (if (eq (cdr (assoc 0 entObj)) "LWPOLYLINE")
					(progn
					  (setq vertices '())
					  (foreach item entObj
						(if (or (eq (car item) 10) (eq (car item) 11))
						  (setq vertices (append vertices (list (cdr item))))
						)
					  )
					  (setq longestSide 0 longestAngle 0)
					  (repeat (- (length vertices) 1)
						(setq p1 (nth 0 vertices) p2 (nth 1 vertices))
						(setq vertices (cdr vertices))
						(setq dist (distance p1 p2))
						(if (> dist longestSide)
						  (progn
						  
							(setq longestSide dist)
							(setq longestAngle (angle p1 p2))
							(princ "\n")
							(princ longestAngle)
							(if 
								(and 									;; if text angle is between 90° and 270° => we turn in 180° extra 
									(> longestAngle  (/ pi 2))
									(< longestAngle  (/ (* 3 pi) 2))
								)
								(progn	
									(princ "*")
									(setq longestAngle (- longestAngle pi))
									(princ longestAngle)
								)
							)

						  )
						)
					  )
					  (setq mtextObj (subst (cons 50 longestAngle) (assoc 50 mtextObj) mtextObj))
					  (entmod mtextObj)
					  (princ "\nMTEXT rotated successfully.")
					)
					(princ "\nSelected entity is not a polyline.")
				  )
				)
				;;(princ "\nInvalid selection.")
			  )
			(setq i (+ i 1))
		)  ;; ending (repeat (sslength mtexts)
	
	
		(setq j (+ j 1))
	)		;; ending (repeat (sslength plines)

  (princ)
)

...

Expand  

Perfect

  • Like 1
Posted
  On 3/18/2025 at 9:20 AM, Emmanuel Delay said:

Sure.

Same thing, a SSGET, then loop through them all, now counting with j.

 

Keep the other functions; here I only post the main function.

 


(defun c:RotateMtext ( / ent mtexts plines i j mtext is_inside pt entObj mtextObj vertices longestSide longestAngle p1 p2 dist)		;; don't forget these.  Local variables must be listed like this.
	
	;;(setq ent (car (entsel "\nSelect enclosed polyline: ")))
	(setq j 0)
	;;(setq plines (ssget "_x" (list (cons 0 "LWPOLYLINE") (cons 70 129) )))
	(setq plines (ssget (list (cons 0 "LWPOLYLINE") (cons 70 129) )))
	(repeat (sslength plines)
		(setq ent (ssname plines j))
	
		;; this selects all MTEXTS
		(setq mtexts (ssget "_x" (list (cons 0 "MTEXT") )))
		(setq i 0)
		(repeat (sslength mtexts)
		
				;;(setq mtext (car (entsel "\nSelect MTEXT: ")))
				(setq mtext (ssname mtexts i))
			  
				(setq is_inside (point_inside_closed_polyline (setq pt (cdr (assoc 10 (entget mtext)))) ent))
				(if is_inside
				  (princ "\n*")		  
				  (princ "\n|")
				)  
			  
			  (if (and ent mtext is_inside)
				(progn
				
				  (setq entObj (entget ent))
				  (setq mtextObj (entget mtext))
				  (if (eq (cdr (assoc 0 entObj)) "LWPOLYLINE")
					(progn
					  (setq vertices '())
					  (foreach item entObj
						(if (or (eq (car item) 10) (eq (car item) 11))
						  (setq vertices (append vertices (list (cdr item))))
						)
					  )
					  (setq longestSide 0 longestAngle 0)
					  (repeat (- (length vertices) 1)
						(setq p1 (nth 0 vertices) p2 (nth 1 vertices))
						(setq vertices (cdr vertices))
						(setq dist (distance p1 p2))
						(if (> dist longestSide)
						  (progn
							(setq longestSide dist)
							(setq longestAngle (angle p1 p2))
						  )
						)
					  )
					  (setq mtextObj (subst (cons 50 longestAngle) (assoc 50 mtextObj) mtextObj))
					  (entmod mtextObj)
					  (princ "\nMTEXT rotated successfully.")
					)
					(princ "\nSelected entity is not a polyline.")
				  )
				)
				(princ "\nInvalid selection.")
			  )
			(setq i (+ i 1))
		)  ;; ending (repeat (sslength mtexts)
	
	
		(setq j (+ j 1))
	)		;; ending (repeat (sslength plines)

  (princ)
)

 

Notice the line 
(setq plines (ssget "_x" (list (cons 0 "LWPOLYLINE") (cons 70 129) )))

 

the "_X" selects everything in the whole drawing.  If you leave away the "_X"  (which is how I saved the code) then the user is still asked to select the polylines.

See which fits you best.

Expand  

Just a suggestion.

(setq plines (ssget (list (cons 0 "LWPOLYLINE") (cons -4  "&")(cons 70 1) )));; this will select all closed polylines either linetype generation is enabled/disabled.

Posted

Furthermore, it is important to know: in the drawing there will never be a closed LWpolyline inside another?

Posted

If this never happens, then the problem is definitely solved.

Posted

I think it would be better to use entsel for the polyline to avoid duplicate polylines as well. But I think OP is already happy with it then we can apply the first rule. 😆

Join the conversation

You can post now and register later. If you have an account, sign in now to post with your account.
Note: Your post will require moderator approval before it will be visible.

Guest
Unfortunately, your content contains terms that we do not allow. Please edit your content to remove the highlighted words below.
Reply to this topic...

×   Pasted as rich text.   Restore formatting

  Only 75 emoji are allowed.

×   Your link has been automatically embedded.   Display as a link instead

×   Your previous content has been restored.   Clear editor

×   You cannot paste images directly. Upload or insert images from URL.

×
×
  • Create New...